/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class COP0 extends AddressingMode {
  public static final String NAME = "COP0";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          COP0.class,
          "COP0",
          WORD,
          new ArgumentDecls()
              .add("i", INDEX),
          false,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new COP0(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public COP0(final Immediate i) {
    this.i = i;
  }

  @Override
  public String syntax() {
    return String.format("$%d", i.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("%s", i.access().load().toString());
  }

  @Override
  public Location access() {
    return COP0_R.access(i.access().load()).setName(syntax());
  }
}
 