/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class bltz extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         bltz.class,
         "bltz",
         false,
         new ArgumentDecls()
             .add("rs", ArgumentMode.IN, REG.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new bltz(rs, offset);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "bltz",
          true,
          new ArgumentDecls()
              .add("rs", ArgumentMode.IN, REG.INFO)
              .add("offset", SHORT),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction(
        new bltz(
          rs,
          offset
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rs;
  public final Immediate offset;

  public bltz(final REG rs, final Immediate offset) {
    assert REG.INFO.isSupported(rs);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("bltz %s, <label>%d", rs.syntax(), offset.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000001%s00000%s", rs.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    if ((rs.access().load().compareTo(Data.valueOf(WORD, 0x0)) < 0)) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      JMPADDR.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x2))));
    }
  }
}
